// gprod.cpp		ver.0.052
//copyright 1998-2004 Beer[Tsutsumi Hiroyuki]

#include	"gprod.h"

#define	VER		"ver.0.052"
#define	DATE	"2004. 6.18"

int	main()
{
	gprod	app;
	app.Run();
	return(0);
}
//------------------------------------------------
gprod::gprod():BApplication("application/x-vnd.Beer-gprod")
{
#if	B_BEOS_VERSION>=0x0600
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("gpro");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	canvas.Set(0,0,0,0);
	BRect	frame;
	frame.Set(100,100,499,399);
	w=new gprodwindow(frame);
	fp=NULL;		//file-panel
}

void gprod::RefsReceived(BMessage *msg)
{
	entry_ref	eref;
	msg->FindRef("refs",&eref);
	load(eref);
	fp=NULL;		//file-panel
}

void gprod::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					load(eref);
					if(initok)break;
				}
			}
		}break;
		case B_SAVE_REQUESTED:{
			if(canvas!=BRect(0,0,0,0)){
				entry_ref	dir;
				const char	*name;
				msg->FindRef("directory",&dir);
				msg->FindString("name",&name);
				save(dir,name);
			}
			fp=NULL;		//file-panel
		}break;
		case B_CANCEL:{
			fp=NULL;		//file-panel
		}break;
		default:{
			BApplication::MessageReceived(msg);
		}break;
	}
}

void gprod::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"Gprod "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.wht.mmtr.or.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 

void gprod::load(entry_ref &eref)
{
	BFile	f(&eref,O_RDONLY|O_BINARY);
	char	ss[8];
	int	l;
	struct stat	fst;
	f.GetStat(&fst);
	//load header
	char	hd[16];
	f.Read(hd,16);
	if(strncmp(hd,"gprod_01",8))return;
	int	cw=B_BENDIAN_TO_HOST_INT16(*((uint16*)(hd+8)));
	int	ch=B_BENDIAN_TO_HOST_INT16(*((uint16*)(hd+10)));
	//set new-canvas
	initok=false;
	BMessage	mes('fine');
	mes.AddRect("bounds",BRect(0,0,cw-1,ch-1));
	w->PostMessage(&mes,w->v);
	while(!initok);
	//load color-def(toriaezu)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	cc=*(ss+5);
	char	*cd=new char[l];
	f.Read(cd,l);
	for(int i=0;i<cc;i++){
		cx[i]=0;
		for(int j=0;j<64;j++){
			if(B_BENDIAN_TO_HOST_INT32(*((uint32*)cd+i))!=pal[j])continue;
			cx[i]=j;break;
		}
	}
	delete cd;
	//load pattern-def(toriaezu)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	pc=*(ss+5);
	char	*pd=new char[l];
	f.Read(pd,l);
	for(int i=0;i<pc;i++){
		px[i]=0;
		for(int j=0;j<16;j++){
			int	jj;
			for(jj=0;jj<16;jj++){
				if(B_BENDIAN_TO_HOST_INT16(*((uint16*)pd+16*i+jj))!=pat[j][jj])break;
			}
			if(jj<16)continue;
			px[i]=j;break;
		}
	}
	delete pd;
	//load font-name(set font-no-conv-tbl)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	fc=*(ss+5);
	char	*fd=new char[l];
	f.Read(fd,l);
	char	*fp,*sp;
	fp=fd;
	for(int i=0;i<fc;i++){
		fx[i]=dfn;
		sp=fp+strlen(fp)+1;
		for(int j=0;j<fontc;j++){
			if(strcmp(ft[j].fam,fp))continue;
			if(strcmp(ft[j].sty,sp))continue;
			fx[i]=j;break;
		}
		fp=sp+strlen(sp)+1;
	}
	delete fd;
	//load data
	char	*dt;
	dt=new char[8];
	f.Read(dt,8);
	if(strncmp(dt,"data",4))return;
	objs=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	delete dt;
	for(int i=0;i<objs;i++){
		uchar	type;
		f.Read(&type,1);
		if(type==RECT)obj[i]=new obj_rect();
		if(type==ELLIPSE)obj[i]=new obj_ellipse();
		if(type==TEXT)obj[i]=new obj_text();
		if(type==BITMAP)obj[i]=new obj_bitmap();
		if(type==LINE)obj[i]=new obj_line();
		if(type==POLY)obj[i]=new obj_polygon();
		obj[i]->read(f);
	}
	//redraw
	w->PostMessage('edrd',w->v);
}

void gprod::save(entry_ref &dir,const char *name)
{
	uchar	cc,pc,fc;
	for(int i=0;i<udfc;i++)udf[i]=0;
	for(int i=0;i<objs;i++)obj[i]->chk_usedef();
	cc=0;for(int i=0;i<64;i++)cx[i]=(udf[i]&0x01)?cc++:255;
	pc=0;for(int i=0;i<16;i++)px[i]=(udf[i]&0x02)?pc++:255;
	fc=0;for(int i=0;i<fontc;i++)fx[i]=(udf[i]&0x80)?fc++:-1;
	BFile	f;
	BDirectory(&dir).CreateFile(name,&f,false);
	int	l;
	//save header
	char	*p;
	char	hd[16];
	memset(hd,0,16);
	strcpy(hd,"gprod_01");
	*((uint16*)(hd+8))=B_HOST_TO_BENDIAN_INT16(canvas.IntegerWidth()+1);
	*((uint16*)(hd+10))=B_HOST_TO_BENDIAN_INT16(canvas.IntegerHeight()+1);
	f.Write(hd,16);
	//save color-def
	l=4*cc;
	char	*cd=new char[8+l];
	memset(cd,0,8+l);
	strcpy(cd,"col");
	*((uint16*)(cd+6))=B_HOST_TO_BENDIAN_INT16(l);
	*((uchar*)(cd+5))=cc;
	p=cd+8;
	for(int i=0;i<64;i++)if(udf[i]&0x01){
		*((uint32*)p)=B_HOST_TO_BENDIAN_INT32(pal[i]);
		p+=4;
	}
	f.Write(cd,8+l);
	delete cd;
	//save pattern-def
	l=32*pc;
	char	*pd=new char[8+l];
	memset(pd,0,8+l);
	strcpy(pd,"pat");
	*((uint16*)(pd+6))=B_HOST_TO_BENDIAN_INT16(l);
	*((uchar*)(pd+5))=pc;
	p=pd+8;
	for(int i=0;i<16;i++)if(udf[i]&0x02){
		for(int j=0;j<16;j++){
			*((uint16*)p)=B_HOST_TO_BENDIAN_INT16(pat[i][j]);
			p+=2;
		}
	}
	f.Write(pd,8+l);
	delete pd;
	//save font-name
	char	*fd=new char[8+128*fc];
	memset(fd,0,8+128*fc);
	p=fd+8;
	for(int i=0;i<fontc;i++)if(udf[i]&0x80){
		p+=sprintf(p,"%s",ft[i].fam)+1;
		p+=sprintf(p,"%s",ft[i].sty)+1;
	}
	l=p-(fd+8);
	strcpy(fd,"font");
	*((uchar*)(fd+5))=fc;
	*((uint16*)(fd+6))=B_HOST_TO_BENDIAN_INT16(l);
	f.Write(fd,8+l);
	delete fd;
	//save data
	char	*dt;
	dt=new char[8];
	memset(dt,0,8);
	strcpy(dt,"data");
	*((uint16*)(dt+4))=B_HOST_TO_BENDIAN_INT16(objs);
	f.Write(dt,8);
	delete dt;
	for(int i=0;i<objs;i++)obj[i]->write(f);
	//set mime
	BAppFileInfo	fi(&f);
	fi.SetType("data/x-vnd.Beer-gprod");
}
//------------------------------------------------
gprodwindow::gprodwindow(BRect frame):BWindow(frame,"gprod "VER,B_DOCUMENT_WINDOW,0)
{
	ft=NULL;	fx=NULL;	udf=NULL;

	BRect	viewframe,sbvframe,sbhframe,selectframe,toolframe;
	selectframe.Set(0,0,399,32);
	selectframe.OffsetTo(0,20);				//menu=20
	sv=new selectview(selectframe);
	AddChild(sv);

	toolframe.Set(0,0,20,299-20-32);
	toolframe.OffsetTo(0,20+32);			//menu=20
	tv=new toolview(toolframe);
	AddChild(tv);

	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH-20,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20-32);
	viewframe.OffsetTo(toolframe.right+1,selectframe.bottom+1);
	v=new gprodview(viewframe);
	AddChild(v);
	setupmenus();
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height());
	sbvframe.OffsetTo(viewframe.right+1,viewframe.top);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	sbhframe.Set(0,0,viewframe.Width(),B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(viewframe.left,viewframe.bottom+1);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	Show();
	SetPulseRate(100000);
}

bool gprodwindow::QuitRequested()
{
	if(ft)delete ft;
	if(fx)delete fx;
	if(udf)delete udf;
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void gprodwindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	int	w,h;
	w=canvas.IntegerWidth()+20+(int)B_V_SCROLL_BAR_WIDTH;		//+toolview+scrollbar
	h=canvas.IntegerHeight()+20+32+(int)B_H_SCROLL_BAR_HEIGHT;	//+menu+selectview+scrollbar
	if(w<400)w=399;
	if(h<300)h=299;
	SetSizeLimits(399,w,299,h);
	if((Bounds().IntegerWidth()==w)&&(Bounds().IntegerHeight()==h)){w=399;h=299;}
	ResizeTo(w,h);
}

void gprodwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=canvas.Height()-sbv->Bounds().Height();
	rh=canvas.Width()-sbh->Bounds().Width();
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/canvas.Height());
	sbh->SetProportion(sbh->Bounds().Width()/canvas.Width());
	sbv->SetSteps(5,sbv->Bounds().Height());
	sbh->SetSteps(5,sbh->Bounds().Width());

	tv->ResizeTo(tv->Bounds().Width(),height);
	sv->ResizeTo(width,sv->Bounds().Height());
}

BMenu* gprodwindow::setupfonts()
{
	font	ftd;
	be_plain_font->GetFamilyAndStyle(&ftd.fam,&ftd.sty);

	font_family	fontf;
	font_style	fonts;
	fontc=0;
	int fc=count_font_families();
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		fontc+=count_font_styles(fontf);
	}
	ft=new font[fontc];
	fx=new int[fontc];
	udfc=max(64,fontc);
	udf=new uchar[udfc];
	BMenu	*m=new BMenu(_T("Font"));	//font family-style
	int	no=0;
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		int sc=count_font_styles(fontf);
		for(int j=0;j<sc;j++){
			get_font_style(fontf,j,&fonts);
			strcpy(ft[no].fam,fontf);
			strcpy(ft[no].sty,fonts);
			char	s[130];
			sprintf(s,"%s(%s)",fontf,fonts);
			BMessage	*mes=new BMessage('Vchg');mes->AddInt16("fon",no);
			BMenuItem	*mi=new BMenuItem(s,mes);
			mi->SetTarget((BHandler*)v);
			if((!strcmp(ftd.fam,fontf))&&(!strcmp(ftd.sty,fonts))){dfn=no;mi->SetMarked(true);}
			m->AddItem(mi);
			no++;
		}
	}
	m->SetRadioMode(true);
	return(m);
}

void gprodwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mm=new BMenu(_T("New"));
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,399,299));
	  mi=new BMenuItem("400x300",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,639,479));
	  mi=new BMenuItem("640x480",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
/*
	 mi=new BMenuItem("close",new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("save",new BMessage('fiow'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("Save as"),new BMessage('finw'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu(_T("Edit"));
/*
	 mi=new BMenuItem("undo",new BMessage('edun'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("Delete"),new BMessage('edde'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	mb->AddItem(m);

	m=setupfonts();
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
toolview::toolview(BRect frame):BView(frame,"tools",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	mode=0;
}

toolview::~toolview()
{
	if(bm)delete bm;
}

void toolview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(TOOLVIEWCOLOR>>16),(uchar)(TOOLVIEWCOLOR>>8),(uchar)TOOLVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void toolview::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void toolview::MouseDown(BPoint pt)
{
	uint32	m=0;
	if((pt.x<2)||(pt.x>18))return;
	if((pt.y>=2)&&(pt.y<=18))m='drpi';
	if((pt.y>=20)&&(pt.y<=36))m='drre';
	if((pt.y>=38)&&(pt.y<=54))m='drel';
	if((pt.y>=56)&&(pt.y<=72))m='drli';
	if((pt.y>=74)&&(pt.y<=90))m='drpo';
	if((pt.y>=92)&&(pt.y<=108))m='drex';
	if(m){
		BMessage *mes=new BMessage(m);
		Window()->PostMessage(mes,((gprodwindow*)Window())->v);
	}
}

void toolview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int8	d;
			if(!msg->FindInt8("mode",&d))mode=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void toolview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(TOOLVIEWCOLOR);
	for(int i=0;i<6;i++){
		bool	f;
		uint32	fc,bc;
		if(i==0)f=(mode==0);
		if(i==1)f=(mode==1);
		if(i==2)f=(mode==2);
		if(i==3)f=(mode==5);
		if(i==4)f=(mode==6);
		if(i==5)f=(mode==-1);
		if(f){fc=0xffffffff;bc=0x00000000;}else{fc=0x00000000;bc=0xffffffff;}
		int	x=2;
		int	y=i*18+2;
		for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
			*(p+(y+yy)*dy+(x+xx))=(iconpat[i][yy]&(0x8000>>xx))?fc:bc;
		}
	}
	Draw(Bounds());
}
//------------------------------------------------
selectview::selectview(BRect frame):BView(frame,"selector",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	now.fc=7;	now.bc=63;	now.fg=1;	now.bg=0;
	now.fon=dfn;	now.fos=18;		now.pen=1;
	sf=0x00;
}

selectview::~selectview()
{
	if(bm)delete bm;
}

void selectview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(SELECTVIEWCOLOR>>16),(uchar)(SELECTVIEWCOLOR>>8),(uchar)SELECTVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void selectview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	DrawBitmap(bm,BPoint(0,0));
	char	s[32];
	sprintf(s,"font : %2d",now.fos);
	DrawString(s,BPoint(342,12));
	sprintf(s,"pen  : %2d",now.pen);
	DrawString(s,BPoint(342,28));
}

void selectview::MouseDown(BPoint pt)
{
	if(pt.x<128){			//color
		int d=(int)(pt.y/8)*16+(int)(pt.x/8);
		if(d<64){
			BMessage *mes=new BMessage('Vchg');
			if(sf&0x01){now.bc=d;mes->AddInt16("bc",d);}
			else{now.fc=d;mes->AddInt16("fc",d);}
			Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		}
	}else if(pt.x<160){		//now color
		if(pt.y<16)sf&=0xfe;
		else sf|=0x01;
		redraw();
	}else if(pt.x<192){		//now pattern
		if(pt.y<16)sf&=0xfd;
		else sf|=0x02;
		redraw();
	}else if(pt.x<320){		//pattern
		int d=(int)(pt.y/16)*8+(int)((pt.x-192)/16);
		if(d<16){
			BMessage *mes=new BMessage('Vchg');
			if(sf&0x02){now.bg=d;mes->AddInt16("bg",d);}
			else{now.fg=d;mes->AddInt16("fg",d);}
			Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		}
	}else{					//fontsize,pensize
		BMessage *mes=new BMessage('Vchg');
		if(pt.y<16){	//font
			int	d=now.fos;
			d=(pt.x<365)?d-2:d+2;
			if((d>=8)&&(d<=80))now.fos=d;
			mes->AddInt16("fos",now.fos);
		}else{			//pen
			int	d=now.pen;
			d=(pt.x<365)?d-1:d+1;
			if((d>=0)&&(d<=30))now.pen=d;
			mes->AddInt16("pen",now.pen);
		}
		Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		redraw();
	}
}

void selectview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int16	d;
			if(!msg->FindInt16("fc",&d))now.fc=d;
			if(!msg->FindInt16("bc",&d))now.bc=d;
			if(!msg->FindInt16("fg",&d))now.fg=d;
			if(!msg->FindInt16("bg",&d))now.bg=d;
			if(!msg->FindInt16("fos",&d))now.fos=d;
			if(!msg->FindInt16("pen",&d))now.pen=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void selectview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(SELECTVIEWCOLOR);
	int	x,y;
	for(int i=0;i<64;i++){		//color
		uint32	c=pal[i];
		x=(i&0x0f)*8;
		y=(i&0xf0)/2;
		if(c&0xff000000)for(int yy=y+(~c>>29);yy<y+8;yy++){
			for(int xx=x;xx<x+8;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
		}
	}
	for(int i=0;i<16;i++){		//pattern
		x=(i&0x07)*16+192;
		y=(i&0xf8)*2;
		for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
			*(p+(y+yy)*dy+(x+xx))=(pat[i][yy]&(1<<xx))?0xffffffff:0x00000000;
		}
	}
	for(int i=0;i<2;i++){		//now-color
		int	no=(i==0)?now.fc:now.bc;
		if(no>=0){
			uint32	c=pal[no];
			x=144;
			y=i*16;
			if(c&0xff000000)for(int yy=y+(~c>>28);yy<y+16;yy++){
				for(int xx=x;xx<x+16;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
			}
		}
	}
	for(int i=0;i<2;i++){		//now-pattern
		int	no=(i==0)?now.fg:now.bg;
		if(no>=0){
			x=160;
			y=i*16;
			for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
				*(p+(y+yy)*dy+(x+xx))=(pat[no][yy]&(1<<xx))?0xffffffff:0x00000000;
			}
		}
	}

	uint32	tc=B_HOST_TO_LENDIAN_INT32(0xcc0000);
	x=132;
	y=(sf&1)?20:4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[3][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=180;
	y=(sf&2)?20:4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[2][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}

	Draw(Bounds());
}

void selectview::set(s_mode s)
{
	redraw();
}
//------------------------------------------------
gprodview::gprodview(BRect frame):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	canvas=BRect(0,0,0,0);
	bm=NULL;		//no canvas
	bmdd=NULL;		//no drag&drop
	kin=0;
	mdf=false;	mcf=true;

	sel_now.f=0;
	selm=0;
	objs=0;
}

gprodview::~gprodview()
{
	if(bm)delete bm;
	if(bmdd)delete bmdd;
}

void gprodview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
	MakeFocus();
}

void gprodview::Draw(BRect rect)
{
	if(bm){
		DrawBitmap(bm,BPoint(0,0));
	}else{
		SetFontSize(30);
		DrawString("Gprod",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
	if(sel_now.f)drawframe(sel_now.rect);
}

void gprodview::KeyDown(const char *bytes,int32 numBytes)
{
	if(kin)return;
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin|=0x01;		//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin|=0x02;		//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin|=0x04;		//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin|=0x08;	//right
		if(*bytes==B_DELETE)kin|=0x10;							//delete
	}
	if((objs)&&(now.mode==0)){
		int		c;
		if(selm==1){
			object	*t;
			if(kin==1){		//to top
				c=objs-1;
				for(int i=objs-1;i>=0;i--){
					if(obj[i]->sel_pt==0)continue;
					t=obj[i];
					for(int j=i+1;j<=c;j++)obj[j-1]=obj[j];
					obj[c--]=t;
				}
			}
			if(kin==2){		//to bottom
				c=0;
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt==0)continue;
					t=obj[i];
					for(int j=i-1;j>=c;j--)obj[j+1]=obj[j];
					obj[c++]=t;
				}
			}
		}else{
			if(kin==1){	//select first
				obj[0]->sel_pt=-1;
				for(int i=1;i<objs;i++)obj[i]->sel_pt=0;
				selm=1;
			}
			if(kin==2){	//select last
				for(int i=0;i<objs-1;i++)obj[i]->sel_pt=0;
				obj[objs-1]->sel_pt=-1;
				selm=1;
			}
		}
		if(kin==4){		//select back
			c=objs-1;
			for(int i=objs-1;i>=0;i--){
				if(obj[i]->sel_pt==0)continue;
				obj[i]->sel_pt=0;
				c=(i+objs-1)%objs;
			}
			obj[c]->sel_pt=-1;
			selm=1;
		}
		if(kin==8){		//select next
			c=0;
			for(int i=0;i<objs;i++){
				if(obj[i]->sel_pt==0)continue;
				obj[i]->sel_pt=0;
				c=(i+1)%objs;
			}
			obj[c]->sel_pt=-1;
			selm=1;
		}
		if(kin==0x10){	//delete
			BMessage *mes=new BMessage('edde');
			Window()->PostMessage(mes,this);
		}
		redraw();
	}
}

void gprodview::KeyUp(const char *bytes,int32 numBytes)
{
/*
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin&=0xfe;	//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin&=0xfd;	//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin&=0xfb;	//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin&=0xf7;//right
	}
*/
	kin=0;
}

void gprodview::MouseDown(BPoint pt)
{
	SetMouseEventMask(B_POINTER_EVENTS);
	if(!canvas.Contains(pt))return;
	mdf=true;
	mbp=pt;
	uchar	mf=mouse();

	if(now.mode>0){
		redraw(2);						//erase-frame
		if(selm==0){
			if(now.mode==1)obj[objs++]=new obj_rect(pt,now);
			if(now.mode==2)obj[objs++]=new obj_ellipse(pt,now);
			if(now.mode==5)obj[objs++]=new obj_line(pt,now);
			if(now.mode==6)obj[objs++]=new obj_polygon(pt,now);
			selm=-1;		//now create
		}
		int	stt=obj[objs-1]->create(mf==2?CANSEL:PRESS,pt);
		if(stt<0)selm=0;
		if(stt==-2)delete obj[--objs];	//cansel
		if(selm)redraw(6);else redraw(7);
		redraw(7);							//redraw-all
	}else if(now.mode==0){
		int	scf=0;
		for(int i=0;i<objs;i++){
			if(obj[i]->sel_pt==0)continue;
			int	scp=obj[i]->select_chk(pt);
			if(scp<0)scf|=1;
			if(scp>0)scf|=2;
		}
		if(scf==0){				//now_out_of_selected_object
			redraw(6);					//erase-frame
			if(mf==1){
				for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
				selm=-1;
			}
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
		}
		if(scf==1){				//now_move
			selm=2;
		}
		if(scf&2){				//now_edit
			redraw(2);					//erase-frame
			for(int i=0;i<objs;i++)if(obj[i]->sel_pt<0)obj[i]->sel_pt=0;
			redraw(6);					//draw-frame
			selm=3;
		}
	}else{	//to external
		if((selm)&&(sel_now.rect.Contains(pt))){	//drag
			selm=0;	mdf=false;	sel_now.f=0;
			redraw(6);					//erase-frame
			if(bmdd){delete bmdd;bmdd=NULL;}
			bmdd=new BBitmap(sel_now.rect,B_RGB_32_BIT);
			int		dy=bm->BytesPerRow()/4;
			int		w=sel_now.rect.IntegerWidth()+1;
			int		h=sel_now.rect.IntegerHeight()+1;
			uint32	*p=(uint32*)(bm->Bits())+(int)(sel_now.rect.top*dy+sel_now.rect.left);
			uint32	*q=(uint32*)(bmdd->Bits());
			for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(q++)=*(p+dy*y+x);
			BMessage	*mes=ddmessage();
			DragMessage(mes,sel_now.rect);
		}else{
			selm=-1;
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
		}
	}	
}

void gprodview::MouseUp(BPoint pt)
{
	if(!mdf)return;
	mdf=false;	mcf=true;

	if(now.mode>0){
		if(selm<0){
			if(obj[objs-1]->create(RELEASE,pt)<0){
				selm=0;
			}
			redraw();									//redraw-all
		}
	}else{
		if(selm<0){
			if(pt.x<canvas.left)pt.x=canvas.left;
			if(pt.x>canvas.right)pt.x=canvas.right;
			if(pt.y<canvas.top)pt.y=canvas.top;
			if(pt.y>canvas.bottom)pt.y=canvas.bottom;
			sel_now.rect=BRect(mbp,pt);
		}
		if(now.mode==0){
			sel_now.f=0;
			if(selm<2){
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt)continue;
					int	scp=obj[i]->select_chk(sel_now.rect);
					if(scp)selm=1;		//selected_mode
				}
				redraw(6);									//draw-frame
			}else{
				selm=1;
				redraw();									//redraw-all
			}
		}else{
			selm=1;
		}
	}	
}

void gprodview::MouseMoved(BPoint pt, uint32 code,const BMessage *msg)
{
	if(pt==mmp)return;else mmp=pt;
	if((!mdf)&&(!(((now.mode==5)||(now.mode==6))&&(selm<0))))return;
	if(!canvas.Contains(pt))return;
	uchar	mf=mouse();
	redraw(2);
	if(now.mode>0){
		if(selm<0){
			if(obj[objs-1]->create(mdf?PRESSMOVE:RELEASEMOVE,pt)<0){
				selm=0;
			}
		}
	}else{
		if(selm<0)sel_now.rect=BRect(mbp,pt);
		if(now.mode==0){
			if(selm>1){
				if((mcf)&&(mf==4)){
					mcf=false;
					int	c=objs;
					for(int i=0;i<c;i++){
						if(obj[i]->sel_pt<0){		//copy
							obj[objs++]=obj[i]->copy();
							obj[i]->sel_pt=0;
						}else if(obj[i]->sel_pt>0){	//add point(for line,poligon)
						
						
						
						}
					}
				}
				for(int i=0;i<objs;i++){			//move
					if(obj[i]->sel_pt==0)continue;
					obj[i]->move(pt-mbp);
				}
				mbp=pt;
			}
		}
	}
	redraw(6);
}

void gprodview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		dp=dr_pt-dr_off;
	}

	switch(msg->what){
		case B_COPY_TARGET:{	//drop(to external)
			ddcopy(msg);
		}break;
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			const char	*source;
			if((!msg->FindString("source",&source))&&(!strcmp(source,"gprod"))){	//from gprod
				break;
			}
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				be_app->PostMessage(msg,be_app);
				break;
			}
			const char	*name;
			if(!msg->FindString("be:clip_name",&name)){	//image
				BMessage	mes(B_COPY_TARGET);
				int32	idx=0;
				const char	*mime;
				while(!msg->FindString("be:types",idx++,&mime)){
					if(!strncmp(mime,"image",5)){
						mes.AddString("be:types",mime);
    					msg->SendReply(&mes,this);
						break;
					}
				}
				break;
			}
		}	//not break;	(for text-data)
		case 'MIME':{
			Char 	*mime;
			type_code	type;
			if(msg->GetInfo(B_MIME_TYPE,0,&mime,&type)==B_OK){
				long	bc;
				const void	*d;
				if(!strncmp(mime,"image",5)){			//image data
					if(!msg->FindData(mime,B_MIME_TYPE,&d,&bc)){
						BMemoryIO		mem(d,bc);
						BBitmapStream	strm;
						if(strcmp(mime,"image/x-be-bitmap")){
							BTranslatorRoster::Default()->Translate(&mem,NULL,NULL,&strm,B_TRANSLATOR_BITMAP,0,mime);
						}else{
							uchar	tbuf[1024];
							int32	tlen;
							while((tlen=mem.Read(tbuf,1024))>0)strm.Write(tbuf,tlen);
						}
						BBitmap *bmp;
						strm.DetachBitmap(&bmp);
						BRect	r=bmp->Bounds();
						r.OffsetTo(0,0);
						if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
						obj[objs++]=new obj_bitmap(dp,now);
						obj[objs-1]->setbitmap(r,(uint32*)(bmp->Bits()));
						delete bmp;
						redraw();
					}
				}
				if(!strncmp(mime,"text",4)){			//text data
					if(!msg->FindData(mime,B_MIME_DATA,&d,&bc)){	//mime="text/plain"
						char	*str=new char[bc+1];
						strncpy(str,(const char*)d,bc);str[bc]=0;
						if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
						obj[objs++]=new obj_text(dr_pt-dr_off,now);
						obj[objs-1]->settext(str,1);
						delete str;
						redraw();
					}
				}
			}
		}break;
		case 'fine':{
			for(int i=0;i<objs;i++)delete obj[i];
			objs=0;
			delete bm;bm=NULL;
			canvas=BRect(0,0,0,0);
			Window()->Zoom();
			msg->FindRect("bounds",&canvas);
			bm=new BBitmap(canvas,B_RGB_32_BIT,true);
			memset(bm->Bits(),0,bm->BitsLength());
			sel_now.f=0;
			selm=0;
			init();
			Window()->Zoom();
			Invalidate();
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'finw':{
			if(fp==NULL){
				fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'drpi':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=0;
			send2toolv();
		}break;
		case 'drre':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=1;
			send2toolv();
//			send2selv();
		}break;
		case 'drel':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=2;
			send2toolv();
//			send2selv();
		}break;
		case 'drli':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=5;
			send2toolv();
//			send2selv();
		}break;
		case 'drpo':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=6;
			send2toolv();
//			send2selv();
		}break;
		case 'drex':{
			redraw(6);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now.mode=-1;
			send2toolv();
//			send2selv();
		}break;
		case 'edde':{
			int	c=0;
			for(int i=0;i<objs;i++){
				if(obj[i]->sel_pt){
					delete obj[i];
				}else{
					obj[c++]=obj[i];
				}
			}
			objs=c;
			selm=0;
			redraw();
		}break;
		case 'edrd':{
			redraw();
		}break;
		case 'Vchg':{
			int16	d;
			uint32	chgf=0;
			if(!msg->FindInt16("fc",&d)){now.fc=d;chgf|=0x01;}
			if(!msg->FindInt16("bc",&d)){now.bc=d;chgf|=0x02;}
			if(!msg->FindInt16("fg",&d)){now.fg=d;chgf|=0x04;}
			if(!msg->FindInt16("bg",&d)){now.bg=d;chgf|=0x08;}
			if(!msg->FindInt16("fon",&d)){now.fon=d;chgf|=0x10;}
			if(!msg->FindInt16("fos",&d)){now.fos=d;chgf|=0x20;}
			if(!msg->FindInt16("pen",&d)){now.pen=d;chgf|=0x40;}
			send2selv();
			if((now.mode==0)&&(selm)){
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt)obj[i]->set_attr(now,chgf);
				}
				redraw();								//redraw-all
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

uchar gprodview::mouse()
{
	uchar	mf=0;
	BPoint	mp;
	uint32	mb;
	uint32	mk;
	GetMouse(&mp,&mb);
	mk=modifiers();
	mf=(uchar)mb;
	if(mf==1){
		if(mk&B_SHIFT_KEY)mf=2;
		if(mk&B_CONTROL_KEY)mf=4;
	}
	return(mf);
}

BMessage* gprodview::ddmessage()
{
	BMessage	*msg=new BMessage(B_SIMPLE_DATA);
	translator_id	*list;
	int32	num;
	BTranslatorRoster::Default()->GetAllTranslators(&list,&num);
	msg->AddString("be:types","image/x-be-bitmap");
	for(int i=0;i<num;i++){
		int32	numOfTypes;
		const translation_format	*in_types,*out_types;
		BTranslatorRoster::Default()->GetInputFormats(list[i],&in_types,&numOfTypes);
		for(int j=0;j<numOfTypes;j++){
			if(in_types[j].type==B_TRANSLATOR_BITMAP){
				BTranslatorRoster::Default()->GetOutputFormats(list[i],&out_types,&numOfTypes);
				for(int po=0;po<numOfTypes;po++){
					if(out_types[po].type!=B_TRANSLATOR_BITMAP){
						msg->AddString("be:types",out_types[po].MIME);
						msg->AddString("be:filetypes",out_types[po].MIME);			//for output
						msg->AddString("be:type_descriptions",out_types[po].name);	//for menu
					}
				}
				break;
			}
		}
	}
	msg->AddString("be:types",B_FILE_MIME_TYPE);
	msg->AddInt32("be:actions",B_COPY_TARGET);
//	msg->AddInt32("be:actions",B_MOVE_TARGET);
//	msg->AddInt32("be:actions",B_TRASH_TARGET);
	msg->AddString("be:clip_name","Gprod_img");
	msg->AddString("source","gprod");
	return(msg);
}

void gprodview::ddcopy(BMessage *msg){
	if(bmdd==NULL)return;
	BBitmapStream	strm(bmdd);
	entry_ref	dir;
	const char	*name,*mime;
	translator_id	tid;
	uint32	fmt;
	if(msg->FindRef("directory",&dir)==B_OK){
		msg->FindString("name",&name);
		msg->FindString("be:filetypes",&mime);
		BFile	*wf=new BFile();
		BDirectory(&dir).CreateFile(name,wf,false);
		select_trans(mime,&tid,&fmt);
		BTranslatorRoster::Default()->Translate(tid,&strm,NULL,wf,fmt);
		BAppFileInfo	wfi(wf);
		wfi.SetType(mime);
		delete wf;
	}else{
		msg->FindString("be:types",&mime);
		BMallocIO	*dat=new BMallocIO;
		BMessage	*res=new BMessage(B_MIME_DATA);
		if(strcmp(mime,"image/x-be-bitmap")){
			select_trans(mime,&tid,&fmt);
			BTranslatorRoster::Default()->Translate(tid,&strm,NULL,dat,fmt);
		}else{
			uchar	tbuf[1024];
			int32	tlen;
			while((tlen=strm.Read(tbuf,1024))>0)dat->Write(tbuf,tlen);
		}
		res->AddData(mime,B_MIME_DATA,dat->Buffer(),dat->BufferLength());
		msg->SendReply(res);
		delete dat;
		delete res;
	}
	bmdd=NULL;
}

void gprodview::select_trans(const char *mime,translator_id *tid,uint32 *fmt){
	translator_id	*trl;
	int32	trc;
	BTranslatorRoster::Default()->GetAllTranslators(&trl,&trc);
	for(int i=0;i<trc;i++){
		const translation_format	*ofmt;
		int32	cnt;
		BTranslatorRoster::Default()->GetOutputFormats(trl[i],&ofmt,&cnt);
		for(int j=0;j<cnt;j++)if(!strcmp(ofmt[j].MIME,mime)){
			*tid=trl[i];
			*fmt=ofmt[j].type;
			return;
		}
	}
	*tid=0;
	*fmt=0;
}

void gprodview::init()
{
	now.mode=0;
	now.fc=7;	now.bc=63;	now.fg=1;	now.bg=0;
	now.pen=1;
	now.fon=dfn;	now.fos=18;
	initok=true;
	send2toolv();
	send2selv();
}

void gprodview::send2toolv()
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt8("mode",now.mode);
	Window()->PostMessage(mes,((gprodwindow*)Window())->tv);
}

void gprodview::send2selv()
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt16("fc",now.fc);
	mes->AddInt16("bc",now.bc);
	mes->AddInt16("fg",now.fg);
	mes->AddInt16("bg",now.bg);
	mes->AddInt16("fon",now.fon);
	mes->AddInt16("fos",now.fos);
	mes->AddInt16("pen",now.pen);
	Window()->PostMessage(mes,((gprodwindow*)Window())->sv);
}

void gprodview::redraw(char f)
{
	if(bm==NULL)return;
	if(f&1){
		memset(bm->Bits(),0,bm->BitsLength());					//clear
		for(int i=0;i<objs;i++)obj[i]->draw(bm);				//object
	}
	if(f&2)for(int i=0;i<objs;i++)obj[i]->drawframe(bm);		//frame
	if(f&4)Draw(Bounds());										//update screen
}

void gprodview::drawsel(BRect r)
{
	xorbox(r.LeftTop());
	xorbox(r.RightTop());
	xorbox(r.LeftBottom());
	xorbox(r.RightBottom());
}

void gprodview::xorbox(BPoint pp)
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	for(int y=(int)pp.y-2;y<=(int)pp.y+2;y++)for(int x=(int)pp.x-2;x<=(int)pp.x+2;x++){
		if(canvas.Contains(BPoint(x,y)))*(p+x+y*dy)^=0xffffff;
	}
}

void gprodview::drawframe(BRect r)
{
	StrokeRect(r,B_MIXED_COLORS);
}

void gprodview::eraseframe(BRect r)
{
	BRect	rr;
	rr.Set(r.left,r.top,r.right,r.top);			DrawBitmap(bm,rr,rr);
	rr.Set(r.left,r.bottom,r.right,r.bottom);	DrawBitmap(bm,rr,rr);
	rr.Set(r.left,r.top,r.left,r.bottom);		DrawBitmap(bm,rr,rr);
	rr.Set(r.right,r.top,r.right,r.bottom);		DrawBitmap(bm,rr,rr);
}
//------------------------------------------------
object::object()
{
	wr=NULL;
	pts=0;
	pt=NULL;
	cpts=0;
	sel_pt=0;
}
object::object(const BPoint &p,const s_mode &m,int points)
{
	wr=NULL;
	if(points){
		pts=points;
		pt=new BPoint[pts];
	}else{	//for variable-points
		pts=1;
		pt=new BPoint[256];
	}
	pt[0]=p;
	cpts=0;
	sel_pt=0;
}

object::~object()
{
#if	__INTEL__
	if(pt)delete pt;
#endif
	if(wr)delete wr;
}

object* object::copy()
{
/*
	object	*neo=new object();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
*/
return(NULL);
}

int object::create(const uchar &mf,const BPoint &mp)
{
/*
	if((mf==PRESS)&&(cpts<pts)){
		pt[cpts]=mp;
		if(++cpts>=pts)cpts=-1;		//create complete
	}
	return(cpts);
*/
return(-1);
}

int object::select_chk(const BPoint &p)
{
/*
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt)sel_pt=spt;
	return(spt);
*/
return(0);
}
int object::select_chk(const BRect &r)
{
/*
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(r.Contains(rp)||r.Intersects(rp))spt=-1;
	}
	if(spt)sel_pt=spt;
	return(spt);
*/
return(0);
}

void object::set_attr(const s_mode &m,const uint32 &f)
{
/*
printf("object:setattr\n");
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x10)da.fon=m.fon;
	if(f&0x20)da.fos=m.fos;
	if(f&0x40)da.pen=m.pen;
//	if(f&0x80)da.sty=m.sty;

	if(f&0xf0)if(wr){delete wr;wr=NULL;}
*/
}

void object::move(const BPoint &d)
{
/*
	if(sel_pt==0)return;
	for(int i=0;i<pts;i++){
		if((sel_pt<0)||(sel_pt==i+1))pt[i]+=d;
	}
*/
}

void object::draw(BBitmap *bm)
{
	if(cpts>=0)return;							//now create
	uint32	*o=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	if(!wr)obj2ras();

	int16	*wrp=wr;
	int		l=rbounds.left;
	int		t=rbounds.top;
	int		w=rbounds.IntegerWidth()+1;
	int		h=rbounds.IntegerHeight()+1;
	o+=(int)(l+t*dy);
	for(int y=0;y<h;y++){
		int		x=*(wrp++);
		while(1){
			bool	f=(x!=-1);
			if(f){
				uchar	pc=*(wrp++);
				int	x2=*(wrp++);
				if(x2==-1){x2=w;f=false;}
				if(pc==0){
					x=x2;
				}else{
					uchar	pn=(pc==1)?da.fg:da.bg;
					for(;x<x2;x++){//line
						if(!canvas.Contains(BPoint(l+x,t+y)))continue;
						uint32	c=pal[(pat[pn][y&0x0f]&(1<<(x&0x0f)))?da.fc:da.bc];
						uint32	*p=o+(int)(x+y*dy);
						overlap(p,c);
					}
				}
				if(x<w)continue;
			}
			break;
		}
	}
}

void object::drawframe(BBitmap *bm)
{
	if(sel_pt)drawpoint(bm);
	if(cpts<0)return;
	draw2bm(*bm,0);
}

void object::form2ctrlp()
{
}

void object::ctrlp2form()
{
//set rbounds
}

void object::read(BFile &f)
{
}

void object::write(BFile &f)
{
}

void object::settext(const char *s,const uchar &f)
{
}

void object::setbitmap(const BRect &r,const uint32 *d)
{
}

int object::draw2bm(BBitmap &bm,const char f)
{
//f=0.canvas(draw frame)  1.work(xfer raster)
return(0);
}

void object::chk_usedef()
{
	if(attrflag&FGCOL)udf[da.fc]|=0x01;
	if(attrflag&BGCOL)udf[da.bc]|=0x01;
	if(attrflag&FGPAT)udf[da.fg]|=0x02;
	if(attrflag&BGPAT)udf[da.bg]|=0x02;
	if(attrflag&FONT)udf[da.fon]|=0x80;
}

void object::drawpoint(BBitmap *bm)
{
	uint32	*o=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	for(int i=0;i<pts;i++){
		int	x0=pt[i].x;
		int	y0=pt[i].y;
		for(int y=y0-2;y<=y0+2;y++)for(int x=x0-2;x<=x0+2;x++){
			if(!canvas.Contains(BPoint(x,y)))continue;
			uint32	*p=o+(int)(x+y*dy);
			*p^=0xffffffff;
		}
	}
}

void object::overlap(uint32 *p,uint32 c)
{
#if	BYTE_ORDER==__LITTLE_ENDIAN
	BGRA	cc;
#else
	ARGB	cc;
#endif
	BGRA	pp,nn;
	cc.c=c;
	if(cc.u.a==0x00)return;
	if(cc.u.a==0xff){*p=B_HOST_TO_LENDIAN_INT32(c);return;}
	pp.c=*p;
	float	kc=(float)cc.u.a/255;
	float	kp=(float)1-kc;
	nn.u.r=kc*cc.u.r+kp*pp.u.r;
	nn.u.g=kc*cc.u.g+kp*pp.u.g;
	nn.u.b=kc*cc.u.b+kp*pp.u.b;
	nn.u.a=0xff;
	*p=nn.c;
}

void object::obj2ras()
{
	if(wr){delete wr;wr=NULL;}
	if(pts){		//create raster-data
		ctrlp2form();
		BRect	r(0,0,rbounds.IntegerWidth(),rbounds.IntegerHeight());
		BBitmap	*wb=new BBitmap(r,B_GRAYSCALE_8_BIT,TRUE);
		int c=draw2bm(*wb,1);

		wr=new int16[c];
		int16	*wrp=wr;
		uchar	*wp=(uchar*)(wb->Bits());
		int		wdy=wb->BytesPerRow();
		int		w=wb->Bounds().IntegerWidth()+1;
		int		h=wb->Bounds().IntegerHeight()+1;
		for(int y=0;y<h;y++){
			uchar	f1=0;
			for(int x=0;x<w;x++){
				uchar	f2=*(wp+x+y*wdy);
				if(f1!=f2){
					*(wrp++)=x;
					*(wrp++)=f2;
					f1=f2;
				}
			}
			*(wrp++)=-1;
		}
		*(wrp++)=-1;
		delete wb;
	}
}
//------------------------------------------------
object_r::object_r():object()
{
}
object_r::object_r(const BPoint &p,const s_mode &m):object(p,m,4)
{
}

int object_r::create(const uchar &mf,const BPoint &mp)
{
	if((mf==PRESS)&&(cpts==0)){
		pt[3]=pt[2]=pt[1]=pt[0]=mp;
		cpts=1;
	}
	if((mf==RELEASE)&&(cpts==1)){
		pt[3].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
		cpts=-1;		//create complete
	}
	if((mf==PRESSMOVE)&&(cpts==1)){
		pt[3].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
	}
	ctrlp2form();
	return(cpts);
}

int object_r::select_chk(const BPoint &p)
{
	int	spt=0;
	for(int i=0;i<4;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt==0){
		if(da.rec.Contains(p))spt=-1;
	}
	if(spt)sel_pt=spt;
	return(spt);
}
int object_r::select_chk(const BRect &r)
{
	int	spt=0;
	if(r.Contains(da.rec)||r.Intersects(da.rec))spt=-1;
	if(spt)sel_pt=spt;
	return(spt);
}

void object_r::move(const BPoint &d)
{
	if(sel_pt==0)return;
	if((sel_pt>0)&&(editflag<EDITABLE))return;
	if(sel_pt<0){pt[0]+=d;pt[1]+=d;pt[2]+=d;pt[3]+=d;}
	if(sel_pt==1){pt[0]+=d;pt[2].x+=d.x;pt[1].y+=d.y;}
	if(sel_pt==2){pt[1]+=d;pt[3].x+=d.x;pt[0].y+=d.y;}
	if(sel_pt==3){pt[2]+=d;pt[0].x+=d.x;pt[3].y+=d.y;}
	if(sel_pt==4){pt[3]+=d;pt[1].x+=d.x;pt[2].y+=d.y;}
	ctrlp2form();
	if(sel_pt>0)if(wr){delete wr;wr=NULL;}
}
//------------------------------------------------
object_l::object_l():object()
{
}
object_l::object_l(const BPoint &p,const s_mode &m):object(p,m,0)
{
}

int object_l::create(const uchar &mf,const BPoint &mp)
{
	if(mf==PRESS){
		if(cpts==0){
			pt[pts++]=mp;	//next
			cpts++;
		}else{
			BRect	rp(pt[cpts-1].x-2,pt[cpts-1].y-2,pt[cpts-1].x+2,pt[cpts-1].y+2);
			if(rp.Contains(mp)){	//create complete
				pts--;
				cpts=-1;
			}else{
				pt[cpts++]=mp;
				pt[pts++]=mp;	//next
			}
		}
	}
	if(mf==CANSEL){
		cpts--;pts--;
		if(pts<2){
			pts=0;cpts=-2;
		}else{
			pt[pts-1]=mp;
		}
	}
	if((mf==RELEASEMOVE)&&(cpts)){
		pt[pts-1]=mp;
	}
	ctrlp2form();
	return(cpts);
}

int object_l::select_chk(const BPoint &p)
{
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt==0){
		if(da.rec.Contains(p))spt=-1;
	}
	if(spt)sel_pt=spt;
	return(spt);
}
int object_l::select_chk(const BRect &r)
{
	int	spt=0;
	if(r.Contains(da.rec)||r.Intersects(da.rec))spt=-1;
	if(spt)sel_pt=spt;
	return(spt);
}

void object_l::move(const BPoint &d)
{
	if(sel_pt==0)return;
	for(int i=0;i<pts;i++){
		if((sel_pt<0)||(sel_pt-1==i))pt[i]+=d;
	}
	ctrlp2form();
	if(sel_pt>0)if(wr){delete wr;wr=NULL;}
}
//------------------------------------------------
obj_rect::obj_rect():object_r()
{
	objtype=RECT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
}
obj_rect::obj_rect(const BPoint &p,const s_mode &m):object_r(p,m)
{
	objtype=RECT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
	set_attr(m);
}

object* obj_rect::copy()
{
	obj_rect	*neo=new obj_rect();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_rect::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_rect::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_rect::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_rect::read(BFile &f)
{
	int	l=13;
	char	*dt=new char[l];
	f.Read(dt,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+6)));
	da.fc=cx[*((uchar*)(dt+8))];
	da.bc=cx[*((uchar*)(dt+9))];
	da.fg=px[*((uchar*)(dt+10))];
	da.bg=px[*((uchar*)(dt+11))];
	da.pen=*((uchar*)(dt+12));
	delete	dt;
	form2ctrlp();
}

void obj_rect::write(BFile &f)
{
	int	l=14;
	char	*dt=new char[l];
	dt[0]=RECT;
	*((uint16*)(dt+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(dt+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(dt+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(dt+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(dt+9))=cx[da.fc];
	*((uchar*)(dt+10))=cx[da.bc];
	*((uchar*)(dt+11))=px[da.fg];
	*((uchar*)(dt+12))=px[da.bg];
	*((uchar*)(dt+13))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_rect::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
//	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	if(f){	//xfer raster
		wv->SetHighColor(20,0,0);	//fg=1(grayscale)
		wv->SetLowColor(20,20,0);	//bg=2(grayscale)
		memset(bm.Bits(),0,bm.BitsLength());	//clear
		bm.Lock();
		bm.AddChild(wv);
		BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
		wv->FillRect(r,B_SOLID_LOW);
		if(da.pen)wv->StrokeRect(r);
//		if(da.pen)wv->StrokeRoundRect(r,da.pen/2,da.pen/2);
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		wv->StrokeRect(da.rec);
//		wv->StrokeRoundRect(da.rec,da.pen/2,da.pen/2);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerHeight()+1)*9+da.pen*5);
}
//------------------------------------------------
obj_ellipse::obj_ellipse():object_r()
{
	objtype=ELLIPSE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
}
obj_ellipse::obj_ellipse(const BPoint &p,const s_mode &m):object_r(p,m)
{
	objtype=ELLIPSE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
	set_attr(m);
}

object* obj_ellipse::copy()
{
	obj_ellipse	*neo=new obj_ellipse();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_ellipse::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_ellipse::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_ellipse::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_ellipse::read(BFile &f)
{
	int	l=13;
	char	*dt=new char[l];
	f.Read(dt,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+6)));
	da.fc=cx[*((uchar*)(dt+8))];
	da.bc=cx[*((uchar*)(dt+9))];
	da.fg=px[*((uchar*)(dt+10))];
	da.bg=px[*((uchar*)(dt+11))];
	da.pen=*((uchar*)(dt+12));
	delete	dt;
	form2ctrlp();
}

void obj_ellipse::write(BFile &f)
{
	int	l=14;
	char	*dt=new char[l];
	dt[0]=ELLIPSE;
	*((uint16*)(dt+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(dt+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(dt+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(dt+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(dt+9))=cx[da.fc];
	*((uchar*)(dt+10))=cx[da.bc];
	*((uchar*)(dt+11))=px[da.fg];
	*((uchar*)(dt+12))=px[da.bg];
	*((uchar*)(dt+13))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_ellipse::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	if(f){	//xfer raster
		wv->SetHighColor(20,0,0);	//fg=1(grayscale)
		wv->SetLowColor(20,20,0);	//bg=2(grayscale)
		memset(bm.Bits(),0,bm.BitsLength());	//clear
		bm.Lock();
		bm.AddChild(wv);
		BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
		wv->FillEllipse(r,B_SOLID_LOW);
		if(da.pen)wv->StrokeEllipse(r);
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		wv->StrokeEllipse(da.rec);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerHeight()+1)*9+da.pen*5);
}
//------------------------------------------------
obj_text::obj_text():object_r()
{
	objtype=TEXT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|FONT;
	da.str=NULL;
}
obj_text::obj_text(const BPoint &p,const s_mode &m):object_r(p,m)
{
	objtype=TEXT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|FONT;
	da.str=NULL;
	set_attr(m);
}

obj_text::~obj_text()
{
	if(da.str)delete da.str;
}

object* obj_text::copy()
{
	obj_text	*neo=new obj_text();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	neo->da.str=NULL;	neo->settext(da.str,0);
	return(neo);
}

void obj_text::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x10)da.fon=m.fon;
	if(f&0x20)da.fos=m.fos;
//	if(f&0x80)da.sty=m.sty;

	if(f&0x30)if(wr){delete wr;wr=NULL;}
}

void obj_text::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	rbounds=BRect(l,t,r,b);
}

void obj_text::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	rbounds=BRect(l,t,r,b);
}

void obj_text::read(BFile &f)
{
	int	l=15;
	char	*d=new char[l];
	f.Read(d,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+6)));
	da.fc=cx[*((uchar*)(d+8))];
	da.bc=cx[*((uchar*)(d+9))];
	da.fg=px[*((uchar*)(d+10))];
	da.bg=px[*((uchar*)(d+11))];
	da.fon=fx[*((uchar*)(d+12))];
	da.fos=*((uchar*)(d+13));
	int	sl=*((uchar*)(d+14));
	delete	d;
	da.str=new char[sl+1];
	f.Read(da.str,sl);
	da.str[sl]=0;
	form2ctrlp();
}

void obj_text::write(BFile &f)
{
	int	sl=strlen(da.str);
	int	l=16+sl;
	char	*d=new char[l];
	d[0]=TEXT;
	*((uint16*)(d+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(d+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(d+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(d+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(d+9))=cx[da.fc];
	*((uchar*)(d+10))=cx[da.bc];
	*((uchar*)(d+11))=px[da.fg];
	*((uchar*)(d+12))=px[da.bg];
	*((uchar*)(d+13))=fx[da.fon];
	*((uchar*)(d+14))=da.fos;
	*((uchar*)(d+15))=sl;
	memcpy(d+16,da.str,sl);
	f.Write(d,l);
	delete d;
}

void obj_text::settext(const char *s,const uchar &f)
{
	if(da.str){delete da.str;da.str=NULL;}
	da.str=new char[strlen(s)+1];
	strcpy(da.str,s);
	if(f){
		BFont	wf;
		font_height	fh;
		int		w,h;
		wf.SetFamilyAndStyle(ft[da.fon].fam,ft[da.fon].sty);
		wf.SetSize(da.fos);
		w=(int)wf.StringWidth(s);
		wf.GetHeight(&fh);
		h=(int)(fh.ascent+fh.descent);
		int16	l=pt[0].x;
		int16	t=pt[0].y;
		int16	r=l+w-1;
		int16	b=t+h-1;
		pt[1].x=r;	pt[1].y=t;
		pt[2].x=l;	pt[2].y=b;
		pt[3].x=r;	pt[3].y=b;
		cpts=-1;
	}
	ctrlp2form();
}

int obj_text::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	if(f){	//xfer raster
		wv->SetHighColor(20,0,0);	//fg=1(grayscale)
		wv->SetLowColor(20,20,0);	//bg=2(grayscale)
		BFont	wf;
		font_height	fh;
		wf.SetFamilyAndStyle(ft[da.fon].fam,ft[da.fon].sty);
		wf.SetSize(da.fos);
		wf.GetHeight(&fh);
		wv->SetFont(&wf);
		memset(bm.Bits(),0,bm.BitsLength());	//clear
		bm.Lock();
		bm.AddChild(wv);
		BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
		wv->FillRect(r,B_SOLID_LOW);
		if(da.str)wv->DrawString(da.str,BPoint(0,fh.ascent));
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		wv->StrokeRect(da.rec);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerWidth()+1)*3*(rbounds.IntegerHeight()+1));
}
//------------------------------------------------
obj_bitmap::obj_bitmap():object_r()
{
	objtype=BITMAP;	editflag=MOVEONLY;	attrflag=0;
	da.bm=NULL;
}
obj_bitmap::obj_bitmap(const BPoint &p,const s_mode &m):object_r(p,m)
{
	objtype=BITMAP;	editflag=MOVEONLY;	attrflag=0;
	da.bm=NULL;
	set_attr(m);
}

obj_bitmap::~obj_bitmap()
{
	if(da.bm)delete da.bm;
}

object* obj_bitmap::copy()
{
	obj_text	*neo=new obj_text();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	neo->da.bm=NULL;	neo->setbitmap(da.bm->Bounds(),(uint32*)(da.bm->Bits()));
	return(neo);
}

void obj_bitmap::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	int16	l=(int16)da.rec.left;
	int16	t=(int16)da.rec.top;
	int16	r=(int16)da.rec.right;
	int16	b=(int16)da.rec.bottom;
	int	w=r-l+1;
	int	h=b-t+1;
	if(da.bm){
		uint32	*o=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		o+=(int)(l+t*dy);
		uchar	*wp=(uchar*)(da.bm->Bits());
		int		wdy=da.bm->BytesPerRow()/4;
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			if(!canvas.Contains(BPoint(l+x,t+y)))continue;
			if(!da.bm->Bounds().Contains(BPoint(x,y)))continue;
			uint32	c=*((uint32*)wp+x+y*wdy);
			uint32	*p=o+(int)(x+y*dy);
			overlap(p,c);
		}
	}
}

void obj_bitmap::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	rbounds=BRect(l,t,r,b);
}

void obj_bitmap::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	rbounds=BRect(l,t,r,b);
}

void obj_bitmap::read(BFile &f)
{
	int	l=8;
	char	*d=new char[l];
	f.Read(d,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+6)));
	delete	d;
	BRect	r(da.rec);
	r.OffsetTo(0,0);
	da.bm=new BBitmap(r,B_RGB_32_BIT);
	f.Read(da.bm->Bits(),da.bm->BitsLength());
	form2ctrlp();
}

void obj_bitmap::write(BFile &f)
{
	int	bl=da.bm->BitsLength();
	int	l=9+bl;
	char	*d=new char[l];
	d[0]=BITMAP;
	*((uint16*)(d+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(d+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(d+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(d+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	memcpy(d+9,da.bm->Bits(),bl);
	f.Write(d,l);
	delete d;
}

void obj_bitmap::setbitmap(const BRect &rec,const uint32 *d)
{
	if(da.bm){delete da.bm;da.bm=NULL;}
	da.bm=new BBitmap(rec,B_RGB_32_BIT);
//	memcpy(da.bm->Bits(),d,da.bm->BitsLength());
	uint32	*p=(uint32*)(da.bm->Bits());
	uint32	len=da.bm->BitsLength()/4;
	for(int i=0;i<len;i++)p[i]=B_LENDIAN_TO_HOST_INT32(d[i]);
	sint16	l=pt[0].x;
	sint16	t=pt[0].y;
	sint16	r=l+rec.IntegerWidth();
	sint16	b=t+rec.IntegerHeight();
	pt[1].x=r;	pt[1].y=t;
	pt[2].x=l;	pt[2].y=b;
	pt[3].x=r;	pt[3].y=b;
	cpts=-1;
	ctrlp2form();
}

int obj_bitmap::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	if(f){	//xfer raster(not use)
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		wv->StrokeRect(da.rec);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return(0);
}
//------------------------------------------------
obj_line::obj_line():object_l()
{
	objtype=LINE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT;
}
obj_line::obj_line(const BPoint &p,const s_mode &m):object_l(p,m)
{
	objtype=LINE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT;
	set_attr(m);
}

object* obj_line::copy()
{
	obj_line	*neo=new obj_line();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_line::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_line::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_line::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_line::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[pts];
	int	l=pts*4+4;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.pen=*((uchar*)(dt+pts*4+3));
	delete	dt;
	form2ctrlp();
}

void obj_line::write(BFile &f)
{
	int	l=pts*4+6;
	char	*dt=new char[l];
	dt[0]=LINE;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_line::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	if(f){	//xfer raster
		wv->SetHighColor(20,0,0);	//fg=1(grayscale)
//		wv->SetLowColor(20,20,0);	//bg=2(grayscale)
		memset(bm.Bits(),0,bm.BitsLength());	//clear
		bm.Lock();
		bm.AddChild(wv);
		wv->MovePenTo(pt[0]-rbounds.LeftTop());
		for(int i=1;i<pts;i++)wv->StrokeLine(pt[i]-rbounds.LeftTop());
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		wv->MovePenTo(pt[0]);
		for(int i=1;i<pts;i++)wv->StrokeLine(pt[i]);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[0].y;
	for(int i=1;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
//------------------------------------------------
obj_polygon::obj_polygon():object_l()
{
	objtype=POLY;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
}
obj_polygon::obj_polygon(const BPoint &p,const s_mode &m):object_l(p,m)
{
	objtype=POLY;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT;
	set_attr(m);
}

object* obj_polygon::copy()
{
	obj_polygon	*neo=new obj_polygon();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_polygon::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_polygon::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_polygon::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_polygon::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[pts];
	int	l=pts*4+5;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.bg=px[*((uchar*)(dt+pts*4+3))];
	da.pen=*((uchar*)(dt+pts*4+4));
	delete	dt;
	form2ctrlp();
}

void obj_polygon::write(BFile &f)
{
	int	l=pts*4+7;
	char	*dt=new char[l];
	dt[0]=POLY;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=px[da.bg];
	*((uchar*)(dt+pts*4+6))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_polygon::draw2bm(BBitmap &bm,const char f)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	if(f){	//xfer raster
		wv->SetHighColor(20,0,0);	//fg=1(grayscale)
		wv->SetLowColor(20,20,0);	//bg=2(grayscale)
		memset(bm.Bits(),0,bm.BitsLength());	//clear
		bm.Lock();
		bm.AddChild(wv);
		BPoint	tp[256];
		for(int i=0;i<pts;i++)tp[i]=pt[i]-rbounds.LeftTop();
		if(pts>2){
			wv->FillPolygon(tp,pts,B_SOLID_LOW);
			if(da.pen)wv->StrokePolygon(tp,pts);
		}else{
			if(da.pen)wv->StrokeLine(tp[0],tp[1]);
		}
		wv->Sync();
	}else{	//draw frame
		wv->SetHighColor(255,255,255);
//		wv->SetLowColor(0,0,0);
		wv->SetDrawingMode(B_OP_INVERT);
		bm.Lock();
		bm.AddChild(wv);
		if(pts>2){
			wv->StrokePolygon(pt,pts);
		}else{
			wv->StrokeLine(pt[0],pt[1]);
		}
		wv->Sync();
	}
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[pts-1].y;
	for(int i=0;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
